int  Convert_Character(char c);
int  Identify_Instruction();
int  Encode_Instruction(int instruction, int addr_mode);

void Push_File_Status();
void Pop_File_Status();

int  fgetln();
void Analyze_Line();
void Print_Line();
char *Skip_Spaces(char *buffer);
char *Skip_Leading_Spaces(char *buffer);

int  Identify_Character_AddrMode(char c);
int  Identify_Addr_Mode();

void Clear_Symbol();
int  Calculate_Hash(char *string);
void Add_Symbol(char *label, long value);
long Find_Symbol(char *label);
void Debug_Symbol_Table();
void Output_Symbol_Table();

int Identify_PseudoOp();
int Do_PseudoOp_Pass1(int pseudo_op);

int  Identify_Char_Expr(char c);
long Get_Value();
long Expression_Analyzer(char *buffer);
